Index: sansmodels/src/sans/models/c_extensions/WrapperGenerator.py
===================================================================
--- sansmodels/src/sans/models/c_extensions/WrapperGenerator.py	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
+++ sansmodels/src/sans/models/c_extensions/WrapperGenerator.py	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
@@ -0,0 +1,374 @@
+#!/usr/bin/env python
+""" WrapperGenerator class to generate model code automatically.
+"""
+
+import os, sys
+import re
+
+class WrapperGenerator:
+    """ Python wrapper generator for C models
+    
+        The developer must provide a header file describing 
+        the new model.
+        
+        To provide the name of the Python class to be
+        generated, the .h file must contain the following 
+        string in the comments:
+        
+        // [PYTHONCLASS] = my_model
+        
+        where my_model must be replaced by the name of the
+        class that you want to import from sans.models.
+        (example: [PYTHONCLASS] = MyModel
+          will create a class MyModel in sans.models.MyModel.
+          It will also create a class CMyModel in 
+          sans_extension.c_models.)
+          
+        Also in comments, each parameter of the params 
+        dictionary must be declared with a default value
+        in the following way:
+        
+        // [DEFAULT]=param_name=default_value
+        
+        (example:
+            //  [DEFAULT]=radius=20.0
+        )
+          
+        See cylinder.h for an example.
+        
+        
+        A .c file corresponding to the .h file should also
+        be provided (example: my_model.h, my_model.c).
+    
+        The .h file should define two function definitions. For example,
+        cylinder.h defines the following:
+        
+            /// 1D scattering function
+            double cylinder_analytical_1D(CylinderParameters *pars, double q);
+            
+            /// 2D scattering function
+            double cylinder_analytical_2D(CylinderParameters *pars, double q, double phi);
+            
+        The .c file implements those functions.
+        
+        @author: Mathieu Doucet / UTK
+        @contact: mathieu.doucet@nist.gov
+    """
+    
+    def __init__(self, filename):
+        """ Initialization """
+        
+        ## Name of .h file to generate wrapper from
+        self.file = filename
+        
+        # Info read from file
+        
+        ## Name of python class to write
+        self.pythonClass = None
+        ## Parser in struct section
+        self.inStruct = False
+        ## Name of struct for the c object
+        self.structName = None
+        ## Dictionary of parameters
+        self.params = {}
+        ## ModelCalculation module flag
+        self.modelCalcFlag = False
+        ## List of default parameters (text)
+        self.default_list = ""
+        ##description
+        self.description=''
+        ## Dictionary of units
+        self.details = ""
+        
+    def __repr__(self):
+        """ Simple output for printing """
+        
+        rep  = "Python class: %s\n" % self.pythonClass
+        rep += "  struc name: %s\n" % self.structName
+        rep += "  params:     %s\n" % self.params
+        rep += "  description: %s\n"% self.description
+        return rep
+        
+    def read(self):
+        """ Reads in the .h file to catch parameters of the wrapper """
+        
+        # Check if the file is there
+        if not os.path.isfile(self.file):
+            raise ValueError, "File %s is not a regular file" % self.file
+        
+        # Read file
+        f = open(self.file,'r')
+        buf = f.read()
+       
+        self.default_list = "List of default parameters:\n"
+        #lines = string.split(buf,'\n')
+        lines = buf.split('\n')
+        self.details  = "## Parameter details [units, min, max]\n"
+        self.details += "        self.details = {}\n"
+        # Catch Description
+        key = "[DESCRIPTION]"
+        find_description= 0
+        temp=""
+        for line in lines:
+            if line.count(key)>0 :
+                
+                try:
+                    find_description= 1
+                    index = line.index(key)
+                    toks = line[index:].split("=",1 )
+                    temp=toks[1].lstrip().rstrip()
+                    text='text'
+                    key2="<%s>"%text.lower()
+                    if re.match(key2,temp)!=None:
+                        #index2 = line.index(key2)
+                        #temp = temp[index2:]
+                        toks2=temp.split(key2,1)
+                        self.description=toks2[1]
+                        text='text'
+                        key2="</%s>"%text.lower()
+                        if re.search(key2,toks2[1])!=None:
+                            temp=toks2[1].split(key2,1)
+                            self.description=temp[0]
+                            break
+                        #print self.description
+                    else:
+                        self.description=temp
+                        break
+                except:
+                     raise ValueError, "Could not parse file %s" % self.file
+            elif find_description==1:
+                text='text'
+                key2="</%s>"%text.lower()
+                #print "second line",line,key2,re.search(key2,line)
+                if re.search(key2,line)!=None:
+                    tok=line.split(key2,1)
+                    temp=tok[0].split("//",1)
+                    self.description+=tok[1].lstrip().rstrip()
+                    break
+                else:
+                    #if re.search("*",line)!=None:
+                    #    temp=line.split("*",1)
+                    #    self.description+='\n'+temp[1].lstrip().rstrip()
+                    if re.search("//",line)!=None:
+                        temp=line.split("//",1)
+                        self.description+='\n\t\t'+temp[1].lstrip().rstrip()
+                        
+                    else:
+                        self.description+='\n\t\t'+line.lstrip().rstrip()
+                    
+                
+        for line in lines:
+            
+            # Catch class name
+            key = "[PYTHONCLASS]"
+            if line.count(key)>0:
+                try:
+                    index = line.index(key)
+                    #toks = string.split( line[index:], "=" )
+                    toks = line[index:].split("=" )
+                    self.pythonClass = toks[1].lstrip().rstrip()
+                except:
+                    raise ValueError, "Could not parse file %s" % self.file
+                
+            # Catch struct name
+            if line.count("typedef struct")>0:
+                # We are entering a struct block
+                self.inStruct = True
+            
+            if self.inStruct and line.count("}")>0:
+                # We are exiting a struct block
+                self.inStruct = False
+    
+                # Catch the name of the struct
+                index = line.index("}")
+                #toks = string.split(line[index+1:],";")
+                toks = line[index+1:].split(";")
+                # Catch pointer definition
+                #toks2 = string.split(toks[0],',')
+                toks2 = toks[0].split(',')
+                self.structName = toks2[0].lstrip().rstrip()
+          
+            # Catch struct content
+            key = "[DEFAULT]"
+            if self.inStruct and line.count(key)>0:
+                # Found a new parameter
+                try:
+                    index = line.index(key)
+                    toks = line[index:].split("=")
+                    toks2 = toks[2].split()
+                    val = float(toks2[0])
+                    self.params[toks[1]] = val
+                    #self.pythonClass = toks[1].lstrip().rstrip()
+                    units = ""
+                    if len(toks2) >= 2:
+                        units = toks2[1]
+                    self.default_list += "         %-15s = %s %s\n" % \
+                        (toks[1], val, units)
+                    
+                    # Check for min and max
+                    min = "None"
+                    max = "None"
+                    if len(toks2) == 4:
+                        min = toks2[2]
+                        max = toks2[3]
+                    
+                    self.details += "        self.details['%s'] = ['%s', %s, %s]\n" % \
+                        (toks[1].lstrip().rstrip(), units.lstrip().rstrip(), min, max)
+                except:
+                    raise ValueError, "Could not parse input file %s \n  %s" % \
+                        (self.file, sys.exc_value)
+                
+                
+            # Catch need for numerical calculations
+            key = "CalcParameters calcPars"
+            if line.count(key)>0:
+                self.modelCalcFlag = True
+            
+                
+                
+    def write_c_wrapper(self):
+        """ Writes the C file to create the python extension class 
+            The file is written in C[PYTHONCLASS].c
+        """
+        
+        file = open("C"+self.pythonClass+'.c', 'w')
+        template = open("classTemplate.txt", 'r')
+        
+        tmp_buf = template.read()
+        #tmp_lines = string.split(tmp_buf,'\n')
+        tmp_lines = tmp_buf.split('\n')
+        
+        for tmp_line in tmp_lines:
+            
+            # Catch class name
+            newline = self.replaceToken(tmp_line, 
+                                        "[PYTHONCLASS]", 'C'+self.pythonClass)
+            ##catch description
+            #newline = self.replaceToken(tmp_line, 
+            #                            "[DESCRIPTION]", self.description)
+            # Catch class name
+            newline = self.replaceToken(newline, 
+                                        "[MODELSTRUCT]", self.structName)
+            
+            # Dictionary initialization
+            param_str = "// Initialize parameter dictionary\n"
+            for par in self.params:
+                param_str += "        PyDict_SetItemString(self->params,\"%s\",Py_BuildValue(\"d\",%f));\n" % \
+                    (par, self.params[par])
+                
+            newline = self.replaceToken(newline,
+                                        "[INITDICTIONARY]", param_str)
+            
+            # Read dictionary
+            param_str = "// Reader parameter dictionary\n"
+            for par in self.params:
+                param_str += "    self->model_pars.%s = PyFloat_AsDouble( PyDict_GetItemString(self->params, \"%s\") );\n" % \
+                    (par, par)
+                
+            newline = self.replaceToken(newline, "[READDICTIONARY]", param_str)
+                
+            # Name of .c file
+            #toks = string.split(self.file,'.')
+            toks = self.file.split('.')
+            newline = self.replaceToken(newline, "[C_FILENAME]", toks[0])
+            
+            # Include file
+            newline = self.replaceToken(newline, 
+                                        "[INCLUDE_FILE]", self.file)           
+                
+            # Numerical calcs dealloc
+            dealloc_str = "\n"
+            if self.modelCalcFlag:
+                dealloc_str = "    modelcalculations_dealloc(&(self->model_pars.calcPars));\n"
+            newline = self.replaceToken(newline, 
+                                        "[NUMERICAL_DEALLOC]", dealloc_str)     
+                
+            # Numerical calcs init
+            init_str = "\n"
+            if self.modelCalcFlag:
+                init_str = "        modelcalculations_init(&(self->model_pars.calcPars));\n"
+            newline = self.replaceToken(newline, 
+                                        "[NUMERICAL_INIT]", init_str)     
+                
+            # Numerical calcs reset
+            reset_str = "\n"
+            if self.modelCalcFlag:
+                reset_str = "modelcalculations_reset(&(self->model_pars.calcPars));\n"
+            newline = self.replaceToken(newline, 
+                                        "[NUMERICAL_RESET]", reset_str)     
+                
+            # Write new line to the wrapper .c file
+            file.write(newline+'\n')
+            
+            
+        file.close()
+        
+    def write_python_wrapper(self):
+        """ Writes the python file to create the python extension class 
+            The file is written in ../[PYTHONCLASS].py
+        """
+        
+        file = open("../"+self.pythonClass+'.py', 'w')
+        template = open("modelTemplate.txt", 'r')
+        
+        tmp_buf = template.read()
+        tmp_lines = tmp_buf.split('\n')
+        
+        for tmp_line in tmp_lines:
+            
+            # Catch class name
+            newline = self.replaceToken(tmp_line, 
+                                        "[CPYTHONCLASS]", 'C'+self.pythonClass)
+            
+            # Catch class name
+            newline = self.replaceToken(newline, 
+                                        "[PYTHONCLASS]", self.pythonClass)
+            
+            # Include file
+            newline = self.replaceToken(newline, 
+                                        "[INCLUDE_FILE]", self.file)    
+                   
+            # Include file
+            newline = self.replaceToken(newline, 
+                                        "[DEFAULT_LIST]", self.default_list)
+            # Model Description
+            newline = self.replaceToken(newline, 
+                                        "[DESCRIPTION]", self.description)
+            # Parameter details
+            newline = self.replaceToken(newline, 
+                                        "[PAR_DETAILS]", self.details)
+            #print"write",tmp_line 
+            # Write new line to the wrapper .c file
+            file.write(newline+'\n')
+           
+        file.close()
+        
+        
+    def replaceToken(self, line, key, value): #pylint: disable-msg=R0201
+        """ Replace a token in the template file 
+            @param line: line of text to inspect
+            @param key: token to look for
+            @param value: string value to replace the token with
+            @return: new string value
+        """
+        lenkey = len(key)
+        newline = line
+        while newline.count(key)>0:
+            index = newline.index(key)
+            newline = newline[:index]+value+newline[index+lenkey:]
+        return newline
+        
+        
+# main
+if __name__ == '__main__':
+    if len(sys.argv)>1:
+        print "Will look for file %s" % sys.argv[1]
+        app = WrapperGenerator(sys.argv[1])
+    else:
+        app = WrapperGenerator("test.h")
+    app.read()
+    app.write_c_wrapper()
+    app.write_python_wrapper()
+    print app
+   
+# End of file        
Index: sansmodels/src/sans/models/c_extensions/disperser.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/disperser.c	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
+++ sansmodels/src/sans/models/c_extensions/disperser.c	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
@@ -0,0 +1,470 @@
+/** 
+ * Disperser
+ * 
+ * Python class that takes a model and averages its output
+ * for a distribution of its parameters.
+ * 
+ * The parameters to be varied are specified at instantiation time.
+ * The distributions are Gaussian, with std deviations specified for
+ * each parameter at instantiation time.
+ * 
+ * @author   M.Doucet / UTK 
+ */
+ 
+#include <Python.h>
+#include "structmember.h"
+#include <stdio.h>
+#include <stdlib.h>
+#include <math.h>
+#include <time.h>
+
+/// Error object for raised exceptions
+static PyObject * DisperserError = NULL;
+
+// Class definition
+typedef struct {
+    PyObject_HEAD
+    /// Dictionary of parameters for this class
+    PyObject * params;
+    /// Model object to disperse
+    PyObject * model;
+    /// Array of original values
+    double * centers;
+    /// Number of parameters to disperse
+    int n_pars;
+    /// Coordinate system flag
+    int cylindrical;
+} Disperser;
+
+// Function definitions
+double disperseParam(Disperser *self, int iPar, PyObject * pars);
+double Disperser_readDouble(PyObject *p);
+
+/**
+ * Function to deallocate memory for the object
+ */
+static void
+Disperser_dealloc(Disperser * self) {
+    free(self->centers);
+    self->ob_type->tp_free((PyObject*)self);
+}
+
+/**
+ * Function to create a new Disperser object
+ */
+static PyObject *
+Disperser_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
+{
+    Disperser *self;
+    
+    self = (Disperser *)type->tp_alloc(type, 0);
+   
+    return (PyObject *)self;
+}
+
+/**
+ * Initialization of the object (__init__)
+ */
+static int
+Disperser_init(Disperser *self, PyObject *args, PyObject *kwds)
+{
+	PyObject * model;
+	PyObject * paramList;
+	PyObject * sigmaList;
+	
+    if (self != NULL) {
+    	
+    	// Create parameters
+        self->params = PyDict_New();
+        
+		// Get input
+		if ( !PyArg_ParseTuple(args,"OOO",&model, &paramList, &sigmaList) ) {
+		    PyErr_SetString(DisperserError, 
+		    	"Disperser: could not parse to initialize. Need Disperser(model, paramList, sigmaList)");
+			return -1;
+		}
+
+		// Check that the lists are of the right type
+		if( PyList_Check(paramList)!=1 || PyList_Check(sigmaList)!=1 ) {
+			PyErr_SetString(DisperserError,
+				"Disperser: bad input parameters; did not find lists.");
+			return -1;
+		}
+		
+		// Check that the list lengths are compatible
+		if( PyList_GET_SIZE(paramList) != PyList_GET_SIZE(sigmaList) ) {
+			PyErr_SetString(DisperserError,
+				"Disperser: supplied lists are not of the same length.");
+			return -1;
+		} 
+		
+		// Set the data members
+		self->model = model;
+		
+		// Number of parameters to disperse
+		// Let run() find out since values can change
+		self->n_pars = 0;
+
+		// Set default coordinate system as cartesian
+		self->cylindrical = 0;
+
+        // Initialize parameter dictionary
+        // Store the list of parameter names (strings)
+        PyDict_SetItemString(self->params,"paramList", paramList);
+        
+        // Store the list of std deviations (floats)
+        PyDict_SetItemString(self->params,"sigmaList", sigmaList);
+        
+        // Set the default number of points to average over
+        PyDict_SetItemString(self->params,"n_pts",Py_BuildValue("i",25));
+    }
+    return 0;
+}
+
+/**
+ * List of member to make public
+ * Only the parameters and the model are available to python users
+ */
+static PyMemberDef Disperser_members[] = {
+    {"params", T_OBJECT, offsetof(Disperser, params), 0,
+     "Parameters"},
+    {"model", T_OBJECT, offsetof(Disperser, model), 0,
+     "Model to disperse"},
+    {NULL}  /* Sentinel */
+};
+
+/** Read double from PyObject
+ *	TODO: THIS SHOULD REALLY BE ELSEWHERE!
+ *   @param p PyObject
+ *   @return double
+ */
+double Disperser_readDouble(PyObject *p) {
+	double value = 0.0;
+	
+    if (PyFloat_Check(p)==1) {
+        value = (double)(((PyFloatObject *)(p))->ob_fval);
+        //Py_DECREF(p);
+        return value;
+    } else if (PyInt_Check(p)==1) {
+        value = (double)(((PyIntObject *)(p))->ob_ival);
+    	//Py_DECREF(p);
+        return value;
+    } else if (PyLong_Check(p)==1) {
+        value = (double)PyLong_AsLong(p);
+    	//Py_DECREF(p);
+        return value;
+    } else {
+    	//Py_DECREF(p);    	
+        return 0.0;
+    }
+}
+
+
+/**
+ * Function to call to evaluate model
+ * @param args: input q or [qx,qy]
+ * @return: function value
+ */
+static PyObject * runXY(Disperser *self, PyObject *args) {
+	PyObject* pars;
+	int n_pts;
+	int i;
+	double value;
+	PyObject * result;
+	PyObject * temp;
+	
+	// Get parameters
+	
+	// Check that the lists are of the right type
+	if( PyList_Check(PyDict_GetItemString(self->params, "paramList"))!=1 
+		|| PyList_Check(PyDict_GetItemString(self->params, "sigmaList"))!=1 ) {
+		PyErr_SetString(DisperserError,
+			"Disperser: bad input parameters; did not find lists.");
+		return NULL;
+	}
+
+	// Reader parameter dictionary
+    n_pts = PyInt_AsLong( PyDict_GetItemString(self->params, "n_pts") );
+    
+	// Check that the list lengths are compatible
+	if( PyList_GET_SIZE(PyDict_GetItemString(self->params, "paramList")) 
+		!= PyList_GET_SIZE(PyDict_GetItemString(self->params, "sigmaList")) ) {
+		PyErr_SetString(DisperserError,
+			"Disperser: supplied lists are not of the same length.");
+		return NULL;
+	} 
+
+    // Number of parameters to disperse
+    self->n_pars = PyList_GET_SIZE(PyDict_GetItemString(self->params, "paramList"));
+    
+    // Allocate memory for centers
+    free(self->centers);
+    self->centers = (double *)malloc(self->n_pars * sizeof(double));
+	if(self->centers==NULL) {
+	    PyErr_SetString(DisperserError, 
+	    	"Disperser.run could not allocate memory.");
+		return NULL;
+	}
+    
+    // Store initial values of those parameters    
+    for( i=0; i<self->n_pars; i++ ) {
+    	result = PyObject_CallMethod(self->model, "getParam", "(O)", 
+    		PyList_GetItem( PyDict_GetItemString(self->params, "paramList"), i ));
+    		
+    	if( result == NULL ) {
+		    PyErr_SetString(DisperserError, 
+		    	"Disperser.run could not get current parameter values.");
+    		return NULL;
+    	} else {
+    		self->centers[i] = Disperser_readDouble(result);
+    		Py_DECREF(result);
+    	}; 
+    }
+	
+	// Get input and determine whether we have to supply a 1D or 2D return value.
+	if ( !PyArg_ParseTuple(args,"O",&pars) ) {
+	    PyErr_SetString(DisperserError, 
+	    	"Disperser.run expects a q value.");
+		return NULL;
+	}    
+        
+    // Evaluate or calculate average
+    if( self->n_pars > 0 ) {
+		value = disperseParam(self, 0, pars);
+    } else {
+    	 if (self->cylindrical==1) {
+    	 	result = PyObject_CallMethod(self->model, "run", "(O)",pars);
+    	 } else {
+    	 	result = PyObject_CallMethod(self->model, "runXY", "(O)",pars);
+    	 }
+    	 
+    	 if( result == NULL ) {
+		    PyErr_SetString(DisperserError, 
+		    	"Disperser.run failed.");
+    		return NULL; 	 	
+    	 } else {
+    		Py_DECREF(result);
+    	 	return result;
+    	 }
+    }
+    
+    // Put back the original model parameter values
+    for( i=0; i<self->n_pars; i++ ) {
+    	// Maybe we need to decref the double here?
+    	temp = Py_BuildValue("d", self->centers[i]);
+    	result = PyObject_CallMethod(self->model, "setParam", "(OO)", 
+    		PyList_GetItem( PyDict_GetItemString(self->params, "paramList"), i ),
+    		temp );
+    	Py_DECREF(temp);
+    		
+    	if( result == NULL ) {
+		    PyErr_SetString(DisperserError, 
+		    	"Disperser.run could not set back original parameter values.");
+    		return NULL;
+    	} else {
+    		Py_DECREF(result);
+    	}; 
+    }
+    
+	return Py_BuildValue("d",value);    	
+
+}
+
+/**
+ * Function to call to evaluate model
+ * @param args: input q or [q,phi]
+ * @return: function value
+ */
+static PyObject * run(Disperser *self, PyObject *args) {
+	PyObject * output;
+	self->cylindrical = 1;
+	output = runXY(self, args);
+	self->cylindrical = 0;
+	return output;
+}
+
+
+
+
+/**
+ * Gaussian weight
+ * @param mean: mean value of the Gaussian
+ * @param sigma: standard deviation of the Gaussian
+ * @param x: value at which the Gaussian is evaluated
+ * @return: value of the Gaussian
+ */
+double gaussian_weight(double mean, double sigma, double x) {
+	double vary, expo_value;
+    vary = x-mean;
+    expo_value = -vary*vary/(2*sigma*sigma);
+    //return 1.0;
+    return exp(expo_value);
+}
+
+/**
+ * @param iPar: ID of parameter to disperse
+ * @param pars: input parameter to the evaluation function
+ */
+double disperseParam(Disperser *self, int iPar, PyObject * pars) {
+	double sigma;
+	double min_value, max_value;
+	double step;
+	double prev_value;
+	double value_sum;
+	double gauss_sum;
+	double gauss_value;
+	double func_value;
+	double error_sys;
+	double value;
+	int i, n_pts;
+	PyObject *result;
+	PyObject *temp;
+	
+	
+    n_pts = PyInt_AsLong( PyDict_GetItemString(self->params, "n_pts") );
+    
+	// If we exhausted the parameter array, simply evaluate
+    // the model
+    if( iPar < self->n_pars ) {
+            
+		// Average over Gaussian distribution (2 sigmas)
+        value_sum = 0.0;
+        gauss_sum = 0.0;
+            
+        // Get the standard deviation for this parameter
+        sigma = Disperser_readDouble(PyList_GetItem( PyDict_GetItemString(self->params, "sigmaList"), iPar ));
+            
+        // Average over 4 sigmas wide
+        min_value = self->centers[iPar] - 2*sigma;
+        max_value = self->centers[iPar] + 2*sigma;
+            
+        // Calculate step size
+        step = (max_value - min_value)/(n_pts-1);
+            
+        // If we are not changing the parameter, just return the 
+        // value of the function
+        if (step == 0.0) {
+            return disperseParam(self, iPar+1, pars);
+        }
+            
+        // Compute average
+        prev_value = 0.0;
+        error_sys  = 0.0;
+        for( i=0; i<n_pts; i++ ) {
+            // Set the parameter value           
+            value = min_value + (double)i*step;
+                
+            temp = Py_BuildValue("d", value);
+    		result = PyObject_CallMethod(self->model, "setParam", "(OO)",
+    			PyList_GetItem( PyDict_GetItemString(self->params, "paramList"), iPar ), 
+    				temp);
+    		Py_DECREF(temp);
+    			
+		    if( result == NULL ) {
+	  	 	 	printf("Could not set param %i\n", iPar);
+	    	 	// return a value that will create an NAN
+	    	 	return 0.0/(step-step);
+		    } else {
+		    	Py_DECREF(result);
+		    }
+                
+			gauss_value = gaussian_weight(self->centers[iPar], sigma, value);
+            func_value = disperseParam(self, iPar+1, pars);
+
+            value_sum += gauss_value * func_value;
+        	gauss_sum += gauss_value;	
+        }   
+        return value_sum/gauss_sum;
+        
+    } else {
+    	 if (self->cylindrical==1) {
+    	 	result = PyObject_CallMethod(self->model, "run", "(O)",pars);
+    	 } else {
+    	 	result = PyObject_CallMethod(self->model, "runXY", "(O)",pars);
+    	 }
+    	 if( result == NULL ) {
+    	 	printf("Model.run() could not return\n");
+    	 	// return a value that will create an NAN
+    	 	return 0.0/(step-step);
+    	 } else {
+    	 	value = Disperser_readDouble(result);    	 	
+    	 	Py_DECREF(result);
+    	 	return value;
+    	 }
+    }
+	
+}
+
+static PyMethodDef Disperser_methods[] = {
+    {"run",      (PyCFunction)run     , METH_VARARGS,
+      "Evaluate the model at a given input value"},
+    {"runXY",      (PyCFunction)runXY     , METH_VARARGS,
+      "Evaluate the model at a given input value"},
+   {NULL}
+};
+
+static PyTypeObject DisperserType = {
+    PyObject_HEAD_INIT(NULL)
+    0,                         /*ob_size*/
+    "Disperser",             /*tp_name*/
+    sizeof(Disperser),             /*tp_basicsize*/
+    0,                         /*tp_itemsize*/
+    (destructor)Disperser_dealloc, /*tp_dealloc*/
+    0,                         /*tp_print*/
+    0,                         /*tp_getattr*/
+    0,                         /*tp_setattr*/
+    0,                         /*tp_compare*/
+    0,                         /*tp_repr*/
+    0,                         /*tp_as_number*/
+    0,                         /*tp_as_sequence*/
+    0,                         /*tp_as_mapping*/
+    0,                         /*tp_hash */
+    0,                         /*tp_call*/
+    0,                         /*tp_str*/
+    0,                         /*tp_getattro*/
+    0,                         /*tp_setattro*/
+    0,                         /*tp_as_buffer*/
+    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
+    "Disperser objects",           /* tp_doc */
+    0,		               /* tp_traverse */
+    0,		               /* tp_clear */
+    0,		               /* tp_richcompare */
+    0,		               /* tp_weaklistoffset */
+    0,		               /* tp_iter */
+    0,		               /* tp_iternext */
+    Disperser_methods,             /* tp_methods */
+    Disperser_members,             /* tp_members */
+    0,                         /* tp_getset */
+    0,                         /* tp_base */
+    0,                         /* tp_dict */
+    0,                         /* tp_descr_get */
+    0,                         /* tp_descr_set */
+    0,                         /* tp_dictoffset */
+    (initproc)Disperser_init,      /* tp_init */
+    0,                         /* tp_alloc */
+    Disperser_new,                 /* tp_new */
+};
+
+
+static PyMethodDef module_methods[] = {
+    {NULL} 
+};
+
+/**
+ * Function used to add the model class to a module
+ * @param module: module to add the class to
+ */ 
+void addDisperser(PyObject *module) {
+	PyObject *d;
+	
+    if (PyType_Ready(&DisperserType) < 0)
+        return;
+
+    Py_INCREF(&DisperserType);
+    PyModule_AddObject(module, "Disperser", (PyObject *)&DisperserType);
+    
+    d = PyModule_GetDict(module);
+    DisperserError = PyErr_NewException("Disperser.error", NULL, NULL);
+    PyDict_SetItemString(d, "DisperserError", DisperserError);
+}
+
Index: sansmodels/src/sans/models/c_extensions/gaussian.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/gaussian.c	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
+++ sansmodels/src/sans/models/c_extensions/gaussian.c	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
@@ -0,0 +1,58 @@
+/**
+ * Gaussian function
+ */
+
+#include "gaussian.h"
+#include <math.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+
+/**
+ * Function to evaluate 1D Gaussian function.
+ * The function is normalized to the 'scale' parameter.
+ * 
+ * f(x)=scale * 1/(sigma^2*2pi)e^(-(x-mu)^2/2sigma^2)
+ * 
+ * @param pars: parameters of the gaussian
+ * @param x: x-value
+ * @return: function value
+ */
+double gaussian_analytical_1D(GaussianParameters *pars, double x) {
+	double sigma2 = pow(pars->sigma, 2);	
+	return pars->scale / sigma2 * exp( -pow((x-pars->center), 2) / (2*sigma2));
+}
+
+/**
+ * Function to evaluate 2D Gaussian  function
+ * The function is normalized to the 'scale' parameter.
+ * 
+ * f(x,y) = Gaussian(x) * Gaussian(y)
+ * 
+ * where both Gaussians share the same parameters.
+ * 
+ * @param pars: parameters of the gaussian
+ * @param x: x-value
+ * @param y: y-value
+ * @return: function value
+ */
+double gaussian_analytical_2DXY(GaussianParameters *pars, double x, double y) {
+    return gaussian_analytical_1D(pars, x) * gaussian_analytical_1D(pars, y);
+} 
+
+/**
+ * Function to evaluate 2D Gaussian  function
+ * The function is normalized to the 'scale' parameter.
+ * 
+ * f(x,y) = Gaussian(x) * Gaussian(y)
+ * 
+ * where both Gaussians share the same parameters.
+ * 
+ * @param pars: parameters of the gaussian
+ * @param length: length of the (x,y) vector
+ * @param phi: angle relative to x
+ * @return: function value
+ */
+double gaussian_analytical_2D(GaussianParameters *pars, double length, double phi) {
+    return gaussian_analytical_2DXY(pars, length*cos(phi), length*sin(phi));
+} 
